//  Copyright 2022 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, m;
  cin >> n >> m;
  vector a(n, vector<int>(m));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      cin >> a[i][j];
      --a[i][j]; 
    }
  }
  auto isDiag = [&](int r, int c) {
    return a[r][c] % 2 == 1;
  };
  auto check = [&](int r0, int c0, int r1, int c1) {
    return r0 >= 0 && r1 >= 0 && r0 < n && r1 < n && c0 >= 0 && c1 >= 0 && c0 < m && c1 < m && isDiag(r0, c0) && isDiag(r1, c1);
  };
  auto checkCell = [&](int r, int c) {
    auto get = [&](int i, int j) {
      if (i + j == r + c) {
        return i > r ? 1 : 5;
      }
      if (i - j == r - c) {
        return i > r ? 7 : 3;
      }
      if (r + c > i + j) {
        if (r - c > i - j) {
          return 4;
        }
        return 2;
      }
      if (r - c < i - j) {
        return 0;
      }
      return 6;
    };

    int frow = -1;
    int fcol = -1;
    int colIfRow = -1;
    int rowIfCol = -1;
    bool okrow = true;
    bool okcol = true;
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < m; ++j) {
        if (i == r && j == c) {
          continue;
        }
        int need = get(i, j);
        int actual = a[i][j];
        if (need == actual) {
          continue;
        }
        if (need != (actual + 4) % 8) {
          return;
        }
        if (frow < 0) {
          frow = i;
          fcol = j;
          continue;
        }
        if (i != frow) {
          if (colIfRow >= 0 && colIfRow != j) {
            okrow = false;
          } else {
            colIfRow = j;
          }
        }
        if (j != fcol) {
          if (rowIfCol >= 0 && rowIfCol != i) {
            okcol = false;
          } else {
            rowIfCol = i;
          }
        }
      }
    }
    if (okrow) {
      cout << r + 1 << ' ' << c + 1 << '\n';
      cout << frow + 1 << ' ' << colIfRow + 1 << '\n';
      exit(0);
    }
    if (okcol) {
      cout << r + 1 << ' ' << c + 1 << '\n';
      cout << rowIfCol + 1 << ' ' << fcol + 1 << '\n';
      exit(0);
    }
  };
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      bool ch = check(i - 1, j - 1, i + 1, j - 1);
      ch |= check(i + 1, j - 1, i + 1, j + 1);
      ch |= check(i + 1, j + 1, i - 1, j + 1);
      ch |= check(i - 1, j + 1, i - 1, j - 1);
      if (ch) {
        checkCell(i, j);
      }
    }
  }
  checkCell(0, 0);
  checkCell(n - 1, 0);
  checkCell(n - 1, m - 1);
  checkCell(0, m - 1);
  assert(false);

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
