// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int MAXN = 100005;
vector<int> dist(MAXN * 4);

void solve() {
	int n;
	cin >> n;
	n = abs(n);
	assert(n < MAXN);
	cout << dist[n] << "\n";
}

int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	fill(dist.begin(), dist.end(), INF);
	dist[0] = 0;
	queue<int> qu;
	qu.push(0);

	while (szof(qu)) {
		int v = qu.front();
		qu.pop();
		for (int jump = 1; jump < MAXN * 4; jump *= 2) {
			int to = abs(v - jump);
			if (to < MAXN * 4 && dist[to] > dist[v] + 1) {
				qu.push(to);
				dist[to] = dist[v] + 1;
			}
			to = v + jump;
			if (to < MAXN * 4 && dist[to] > dist[v] + 1) {
				qu.push(to);
				dist[to] = dist[v] + 1;
			}
		}
	}

	int test_count = 1;
	cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}