#include "testlib.h"

#include <string>
#include <vector>

using namespace std;

typedef long long ll;
typedef __int128 lll;

lll get(lll x) {
    if (!x) {
        return 1;
    }
    int ans = 0;
    while (x) {
        ans++;
        x /= 10;
    }
    return ans;
}

lll getAns(InStream &stream, ll S) {
    lll len = stream.readLong();
    if (len == -1) {
        return -1;
    }
    lll l = stream.readLong(0, 1'000'000'000'000'000'000LL);
    lll r = stream.readLong(l, 1'000'000'000'000'000'000LL);
    vector<lll> cnt(1);
    vector<lll> p = {1, 10};
    cnt.push_back(9);
    for (int i = 2; i <= 17; i++) {
        p.push_back(p.back() * 10);
        cnt.push_back(cnt.back() * 10);
    }
    cnt[1] = 10;
    lll lb = get(l);
    lll rb = get(r);
    lll ans = 0;
    if (lb == rb) {
        ans = lb * (r - l + 1);
    } else {

        for (lll i = lb + 1; i < rb; i++) {
            ans += i * cnt[i];
        }

        ans += (p[lb] - l) * lb;
        ans += (r - p[rb - 1] + 1) * rb;
    }
    if (ans != S || r - l + 1 != len) {
        stream.quitf(_wa, "Incorrect sum[l, r] = %lld != %lld", (ll) S, (ll) ans);
    }

    return len;
}

int main(int argc, char *argv[])
{
    registerTestlibCmd(argc, argv);
    ll n = inf.readLong();

    lll pa = getAns(ouf, n);
    lll ja = getAns(ans, n);
    if (pa != ja && pa == -1) {
        quitf(_wa, "-1 unexpected");
    }
    if (pa != ja && ja == -1) {
        quitf(_fail, "jury thought it was -1");
    }
    if (pa < ja) {
        quitf(_wa, "too few numbers, expected %lld, found %lld", (ll) ja, (ll) pa);
    } else if (pa > ja) {
        quitf(_fail, "jury thought %lld, participant %lld", (ll) ja, (ll) pa);
    }
    quitf(_ok, "");

    return 0;
}

