//  Copyright 2022 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = __int128;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

//  upto 10^36
ostream& operator<<(ostream& out, __int128 x) {
  if (x < 0) {
    out << "-";
    x = -x;
  }
#define ll int64_t
  static constexpr ll BASE = ll(1e18);
  if (x < BASE) {
    return out << ((ll) x);
  }
  return out << (ll) (x / BASE) << setw(18) << setfill('0') << (ll) (x % BASE);
#undef ll
}

//  long long
istream& operator>>(istream& in, __int128& x) {
#define ll int64_t
  ll y; in >> y; x = y;
  return in;
#undef ll
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  ll S; cin >> S;
  pair<ll, ll> ans{-1, -2};

  auto upd = [&](ll l, ll r) {
    assert(r >= l);
    if (r - l > ans.second - ans.first) {
      ans = make_pair(l, r);
    }
  };

  vector<ll> powers(19);
  powers[0] = 1;
  for (int i = 1; i <= 18; ++i) {
    powers[i] = powers[i - 1] * 10;
  }

  auto getCnt = [&](int len) { 
    return len == 19 ? 1ll : len == 1 ? 10 : powers[len] - powers[len - 1];
  };  
  auto getFirst = [&](int len) {
    return len == 1 ? 0 : powers[len - 1];
  };

  for (int len1 = 1; len1 <= 19; ++len1) {
    if (S % len1 == 0 && S / len1 <= getCnt(len1)) {
      upd(getFirst(len1), getFirst(len1) + S / len1 - 1);
    }
    for (int len2 = len1 + 1; len2 <= 19; ++len2) {
      ll full = 0;
      for (int i = len1 + 1; i < len2; ++i) {
        full += getCnt(i) * i;
      }
      ll c = S - full;
      if (c < 0) {
        continue;
      }
      ll LX = getCnt(len1);
      ll LY = getCnt(len2);
      //  len1 * x + len2 * y = c
      //  0 <= x <= LX
      //  0 <= y <= LY

      auto updCount = [&](ll cx, ll cy) {
        upd(getFirst(len1 + 1) - cx, getFirst(len2) + cy - 1);
      };
      auto updX = [&](ll x) {
        ll nc = c - x * len1;
        if (nc % len2 == 0) {
          nc /= len2;
          if (nc >= 0 && nc <= LY) {
            updCount(x, nc);
          }
        }
      };
      auto updY = [&](ll y) {
        ll nc = c - y * len2;
        if (nc % len1 == 0) {
          nc /= len1;
          if (nc >= 0 && nc <= LX) {
            updCount(nc, y);
          }
        }
      };

      for (ll step = 0; step <= 10000; ++step) {
        if (step <= LX) {
          updX(step);
          updX(LX - step);
        }
        if (step <= LY) {
          updY(step);
          updY(LY - step);
        }
      }
    }
  }

  if (ans.first == -1) {
    cout << -1 << '\n';
  } else {
    cout << ans.second - ans.first + 1 << '\n';
    cout << ans.first << ' ' << ans.second << '\n';
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
