using namespace std;

#include <unordered_set>
#include <queue>
#include "testlib.h"

const int max_str_len = 2000'000;
typedef long long ll;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    vector<char> ex_chars;
    for (int c = 'a'; c <= 'z'; ++c) { ex_chars.push_back(c); }
    int different_chars = has_opt("c") ? opt<int>("c") : 10;
    vector<char> chars;
    for (int i = 0; i < different_chars; ++i) {
        int p = rnd.next(0, static_cast<int>(ex_chars.size()) - 1);
        chars.push_back(ex_chars[p]);
        ex_chars[p] = ex_chars.back();
        ex_chars.pop_back();
    }

    int max_m = has_opt("m") ? opt<int>("m") : 1000'000;
    int max_n = opt<int>("n");
    int n = (1 + rnd.wnext(max_n, 10)) / 2 * 2;
    int len = static_cast<int>(min(static_cast<ll>(max_str_len), static_cast<ll>(n) * static_cast<ll>(max_m)));
    int m = 1 + rnd.wnext(len / n, 10);

    int k_min = rnd.next(0, m);
    int k_max = rnd.next(0, m);
    if (k_max < k_min) { swap(k_min, k_max); }
    k_max = k_min;

    printf("%d\n", n);

    vector <string> ss(n);
    for (int i = 0; i < n / 2; ++i) {
        int k = rnd.next(k_min, k_max);
        for (int j = 0; j < k; ++j) {
            char c = chars[rnd.next(0, different_chars - 1)];
            ss[i * 2] += c;
            ss[i * 2 + 1] += c;
        }
        int u = 1 + rnd.wnext(m - k, -3);
        for (int j = 0; j < u; ++j) {
            ss[i * 2] += chars[rnd.next(different_chars)];
            ss[i * 2 + 1] += chars[rnd.next(different_chars)];
        }
        for (int j = 0; j < m - k - u; ++j) {
            char c = chars[rnd.next(0, different_chars - 1)];
            ss[i * 2] += c;
            ss[i * 2 + 1] += c;
        }
    }

    shuffle(ss.begin(), ss.end());

    for (int i = 0; i < n; ++i) {
        printf("%s\n", ss[i].c_str());
    }
}
