//
// by Grigoriy Khlytin on 21.10.2022
//

#include "testlib.h"

using namespace std;

typedef long long int ll;

void cols_rows_gen(ll &x1, ll &y1, ll &x2, ll &y2, ll MAX_X, ll MAX_Y) {
    x1 = rnd.next(-MAX_X, MAX_X);
    y1 = rnd.next(-MAX_Y, MAX_Y);
    if (rnd.next(0LL, 1LL) == 0LL) {
        x2 = x1;
        while (true) {
            y2 = rnd.next(-MAX_Y, MAX_Y);
            if (y1 != y2) break;
        }
    } else {
        y2 = y1;
        while (true) {
            x2 = rnd.next(-MAX_X, MAX_X);
            if (x1 != x2) break;
        }
    }
}

void diagonals_gen(ll &x1, ll &y1, ll &x2, ll &y2, ll MAX_X, ll MAX_Y) {
    ll a = MAX_X / 2LL;
    ll b = MAX_Y / 2LL;
    ll c = min(a, b);
    x1 = rnd.next(-a, a);
    y1 = rnd.next(-b, b);
    ll d = 0LL;
    while (d == 0LL) {
        d = rnd.next(-c, c);
    }
    x2 = x1 + d;
    y2 = y1 + d;
}

void chain_gen(ll &x1, ll &y1, ll &x2, ll &y2, ll MAX_X, ll MAX_Y) {
    while (true) {
        x2 = rnd.next(-MAX_X, MAX_X);
        y2 = rnd.next(-MAX_Y, MAX_Y);
        if (x1 != x2 || y1 != y2) break;
    }
}

void commons_gen(ll &x1, ll &y1, ll &x2, ll &y2, ll MAX_X, ll MAX_Y) {
    x1 = rnd.next(-MAX_X, MAX_X);
    y1 = rnd.next(-MAX_Y, MAX_Y);
    while (true) {
        x2 = rnd.next(-MAX_X, MAX_X);
        y2 = rnd.next(-MAX_Y, MAX_Y);
        if (x1 != x2 || y1 != y2) break;
    }
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    ll typ = opt<int>("type");
    ll M = opt<int>("m");
    ll MAX_X = opt<int>("x");
    ll MAX_Y = opt<int>("y");

    M = max(3LL, M);
    MAX_X = max(2LL, MAX_X);
    MAX_Y = max(2LL, MAX_Y);

    ll m = rnd.next(max(3LL, M / 2LL), M);

    if (typ == 0LL) {
        m = 100LL;
        MAX_X = 10000LL;
        MAX_Y = 10000LL;
    }

    println(m);

    switch (typ) {
        case 1:
            for (ll i = 0; i < m; i++) {
                ll x1, y1, x2, y2;
                cols_rows_gen(x1, y1, x2, y2, MAX_X, MAX_Y);
                println(x1, y1, x2, y2);
            }
            break;
        case 2:
            for (ll i = 0; i < m; i++) {
                ll x1, y1, x2, y2;
                diagonals_gen(x1, y1, x2, y2, MAX_X, MAX_Y);
                println(x1, y1, x2, y2);
            }
            break;
        case 3: {
            ll x1, y1, x2, y2;
            ll st = rnd.next(1LL, m - 1LL);
            x1 = rnd.next(-MAX_X, MAX_X);
            y1 = rnd.next(-MAX_Y, MAX_Y);
            for (ll i = 0; i < st; i++) {
                chain_gen(x1, y1, x2, y2, MAX_X, MAX_Y);
                println(x1, y1, x2, y2);
                x1 = x2;
                y1 = y2;
            }
            x1 = rnd.next(-MAX_X, MAX_X);
            y1 = rnd.next(-MAX_Y, MAX_Y);
            for (ll i = st; i < m; i++) {
                chain_gen(x1, y1, x2, y2, MAX_X, MAX_Y);
                println(x1, y1, x2, y2);
                x1 = x2;
                y1 = y2;
            }
        }
            break;
        default:
            for (ll i = 0; i < m; i++) {
                ll x1, y1, x2, y2;
                ll r = rnd.next(0LL, 2LL);
                if (r == 0LL) {
                    cols_rows_gen(x1, y1, x2, y2, MAX_X, MAX_Y);
                } else if (r == 1LL) {
                    diagonals_gen(x1, y1, x2, y2, MAX_X, MAX_Y);
                } else {
                    commons_gen(x1, y1, x2, y2, MAX_X, MAX_Y);
                }
                println(x1, y1, x2, y2);
            }
            break;
    }

}
