// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

ll sqr(int num) {
	return (ll) num * num;
}

int sign(ll num) {
	return num < 0 ? -1 : (num > 0 ? 1 : 0);
}

struct point {
	int x, y;
	point(int _x, int _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	ll len2() const {
		return sqr(x) + sqr(y);
	}

	bool operator<(point const& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}

	bool operator<=(point const& other) const {
		return x < other.x || (x == other.x && y <= other.y);
	}
};

ll cross(point const& p1, point const& p2) {
	return (ll) p1.x * p2.y - (ll) p1.y * p2.x;
}

ll dot(point const& p1, point const& p2) {
	return (ll) p1.x * p2.x + (ll) p1.y * p2.y;
}

ll p_dist_sq(point const& p1, point const& p2) {
	return (p1 - p2).len2();
}

struct rational {
	ll p, q;
	rational(ll num) : p(num), q(1) {}
	rational(ll _p, ll _q) : p(_p), q(_q) {
		if (q < 0) {
			p *= -1;
			q *= -1;
		}
	}
};

bool operator<(rational const& r1, rational const& r2) {
	return (__int128_t) r1.p * r2.q < (__int128_t) r2.p * r1.q;
}

bool operator<=(rational const& r1, rational const& r2) {
	return (__int128_t) r1.p * r2.q <= (__int128_t) r2.p * r1.q;
}

rational p_to_seg_dist_sq(point const& p, pair<point, point> const& s) {
	if (dot(s.ss - s.ff, p - s.ff) <= 0) {
		return p_dist_sq(p, s.ff);
	}
	if (dot(s.ff - s.ss, p - s.ss) <= 0) {
		return p_dist_sq(p, s.ss);
	}
	return rational(sqr(cross(s.ss - s.ff, p - s.ff)), p_dist_sq(s.ff, s.ss));
}

bool segs_intersect(pair<point, point> s1, pair<point, point> s2) {
	if (cross(s1.ss - s1.ff, s2.ff - s1.ff) == 0 && 
		cross(s1.ss - s1.ff, s2.ss - s1.ff) == 0) {
		if (s1.ss < s1.ff) {
			swap(s1.ff, s1.ss);
		}
		if (s2.ss < s2.ff) {
			swap(s2.ff, s2.ss);
		}
		return max(s1.ff, s2.ff) <= min(s1.ss, s2.ss);
	}
	return sign(cross(s1.ss - s1.ff, s2.ff - s1.ff)) * 
		sign(cross(s1.ss - s1.ff, s2.ss - s1.ff)) <= 0 && 
		sign(cross(s2.ss - s2.ff, s1.ff - s2.ff)) * 
		sign(cross(s2.ss - s2.ff, s1.ss - s2.ff)) <= 0;
}

rational segs_dist_sq(pair<point, point> const& s1, pair<point, point> const& s2) {
	if (segs_intersect(s1, s2)) {
		return 0;
	}
	rational ret = p_to_seg_dist_sq(s1.ff, s2);
	ret = min(ret, p_to_seg_dist_sq(s1.ss, s2));
	ret = min(ret, p_to_seg_dist_sq(s2.ff, s1));
	ret = min(ret, p_to_seg_dist_sq(s2.ss, s1));
	return ret;
}

void solve() {
	int n;
	cin >> n;
	vector<pair<point, point>> segs;
	for (int i = 0; i < n; ++i) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		segs.push_back({point(x1, y1), point(x2, y2)});
	}

	int ans = 0;

	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			for (int k = j + 1; k < n; ++k) {
				if (segs_dist_sq(segs[i], segs[j]) <= p_dist_sq(segs[k].ff, segs[k].ss)) {
					++ans;
					continue;
				}

				if (segs_dist_sq(segs[i], segs[k]) <= p_dist_sq(segs[j].ff, segs[j].ss)) {
					++ans;
					continue;
				}

				if (segs_dist_sq(segs[j], segs[k]) <= p_dist_sq(segs[i].ff, segs[i].ss)) {
					++ans;
					continue;
				}
			}
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}